package org.jicengine;
import org.jicengine.io.Resource;
import java.util.Map;
import java.io.IOException;

/**
 * <p>
 * An interface for accessing the current build-context within
 * JIC-files. An instance of this class is available by default in
 * all JIC-files under the name 'JICEContext'.
 * </p>
 * <p>
 * BuildContext makes it possible to reference the current JIC-file,
 * the build-attributes, etc. (in the future, this interface could be
 * used for letting the JIC-files also customize their environment.)
 * </p>
 *
 * @author .timo
 *
 */

public interface BuildContext {

	public static final String VARIABLE_NAME = "JICEContext";

	public Resource getResource(String relativePath) throws IOException;

	public Resource getCurrentFile();

	public Map getParameters();

}
