package org.jicengine.builder;

import org.jicengine.operation.ReflectionUtils;

import org.jicengine.element.*;
import org.jicengine.element.Type;
import java.util.*;

/**
 *
 *
 *
 *
 * @author .timo
 *
 */

public class TypeManagerImpl implements TypeManager {

	private Map typeNamesToClassesMap;

	public TypeManagerImpl(Map elements)
	{
		this.typeNamesToClassesMap = elements;
	}

	public ElementCompiler createCompiler(String name, Location location, Type elementType) throws Exception {
		Class elementClass = (Class) this.typeNamesToClassesMap.get(elementType.getName());
		if( elementClass == null ){
			throw new IllegalArgumentException("Type named '" + elementType.getName() + "' not supported. use " + this.typeNamesToClassesMap.keySet());
		}

		String[] typeParameters = elementType.getParameters();
		Object[] parameters = new Object[typeParameters.length + 2];
		parameters[0] = name;
		parameters[1] = location;
		for (int i = 0; i < typeParameters.length; i++) {
			parameters[i+2] = typeParameters[i];
		}

		try {
			ElementCompiler element = (ElementCompiler) org.jicengine.operation.ReflectionUtils.instantiate(elementClass, parameters);
			return element;
		} catch (Exception e){
			throw new org.jicengine.util.ChainedRuntimeException("Failed to create element of type " + elementType.getSignature(),e);
		}
	}
}
