package org.jicengine.element;

import org.jicengine.util.ChainedRuntimeException;

/**
 *
 * @author .timo
 *
 */

public class ElementException extends ChainedRuntimeException {

	public ElementException(String message, String elementName, Location location)
	{
		super(decorateMessage(message, elementName, location));
	}

	public ElementException(String message, Throwable cause, String elementName, Location location)
	{
		super(decorateMessage(message, elementName, location), cause);
	}

	public ElementException(Throwable cause, String elementName, Location location)
	{
		super(decorateMessage(cause.getMessage(), elementName, location), cause);
	}

	private static String decorateMessage(String message, String elementName, Location location)
	{
		return message + " (<" + elementName + "> at " + location + ")";
	}
}
