package org.jicengine.element;


/**
 *
 *
 * @author .timo
 */

public abstract class Type {

	String name;
	String[] parameters;
	String signature;

	protected Type(String name, String[] parameters)
	{
		this.name = name;
		this.parameters = parameters;
		this.signature = name + "/" + parameters.length;
	}

	public String getName()
	{
		return this.name;
	}

	public String getSignature()
	{
		return this.signature;
	}

	public String[] getParameters()
	{
		return this.parameters;
	}

	public static Type parse(String typeExpression)
	{
		Object[] signature = org.jicengine.expression.Utils.parseSignature(typeExpression);
		String name = (String) signature[0];
		String[] params = (String[]) signature[1];
		return new SimpleType(name, params);
	}

	public String toString()
	{
		return this.signature;
	}
}
