package org.jicengine.element.impl;

import org.jicengine.operation.OperationException;

import org.jicengine.operation.Context;

import org.jicengine.operation.Operation;

import org.jicengine.element.*;

/**
 *
 *
 *
 *
 * @author .timo
 *
 */

public class BeanElementCompiler extends ElementCompiler {

	public BeanElementCompiler(String name, Location location)
	{
		super(name, location);
	}

	/**
	 * transforms the child into a property setter action..
	 */
	protected ActionElement handleExtraChildElement(final ValueElement child) throws ElementException
	{
		try {
			Operation setPropertyAction = org.jicengine.expression.LJEParser.getInstance().parse(getSetPropertyActionExpression(child.getName()) );

			return new WrapperActionElement(child, getLocation(), setPropertyAction);

		} catch (org.jicengine.expression.SyntaxException e){
			throw new ElementException(e,getName(), getLocation());
		}
	}

	/**
	 * 'childElement' -> this.setChildElement(childElement)
	 */
	public static String getSetPropertyActionExpression(String propertyName)
	{
		return Element.VARIABLE_NAME_PARENT_INSTANCE + ".set" + Character.toUpperCase(propertyName.charAt(0)) + propertyName.substring(1) + "(" + Element.VARIABLE_NAME_ELEMENT_INSTANCE + ")";
	}
}
