package org.jicengine.element.impl;
import org.jicengine.element.Element;
import org.jicengine.element.Location;
import java.util.StringTokenizer;
import java.awt.Color;

/**
 *
 *
 *
 *
 * @author .timo
 *
 */

public class ColorCompiler extends StrictElementCompiler {

	public ColorCompiler(String name, Location location) throws org.jicengine.expression.SyntaxException
	{
		super(name, location);
		setConstructor(ColorCompiler.class.getName() + ".toColor(" + Element.VARIABLE_NAME_CDATA + ")");
	}

	public static Color toColor(String colorSpec)
	{
		try {
			int red;
			int green;
			int blue;
			int alpha = 255;

			if( colorSpec.indexOf(",") != -1 ){
				// a color as numbers
				StringTokenizer tokenizer = new StringTokenizer(colorSpec, ",");
				red = Integer.parseInt(tokenizer.nextToken());
				green = Integer.parseInt(tokenizer.nextToken());
				blue = Integer.parseInt(tokenizer.nextToken());
				if( tokenizer.hasMoreTokens()){
					alpha = Integer.parseInt(tokenizer.nextToken());
				}
			}
			else {
				// a color as a hex
				red = Integer.parseInt(colorSpec.substring(0,2),16);
				green = Integer.parseInt(colorSpec.substring(2,4),16);
				blue = Integer.parseInt(colorSpec.substring(4,6),16);
				if( colorSpec.length() == 8 ){
					alpha = Integer.parseInt(colorSpec.substring(6),16);
				}
			}
			return new Color(red, green, blue, alpha);
		} catch (Exception e){
			throw new IllegalArgumentException("Failed to parse '" + colorSpec + "' to a java.awt.Color : " + e);
		}
	}
}
