package org.jicengine.element.impl;

import org.jicengine.expression.SyntaxException;
import org.jicengine.operation.Context;
import org.jicengine.operation.Operation;

import org.jicengine.element.*;
import java.util.*;

/**
 *
 *
 *
 *
 * @author .timo
 *
 */

public class ListElementCompiler extends ElementCompiler {

	public ListElementCompiler(String name, Location location) throws ElementException
	{
		super(name, location);
	}

	public void elementInitialized() throws ElementException
	{
		super.elementInitialized();

		if( getConstructor() == null ){
			setConstructor("new java.util.ArrayList()");
		}
	}

	protected ActionElement handleExtraChildElement(ValueElement child) throws ElementException
	{
		try {
			Operation addToListOperation = org.jicengine.expression.LJEParser.getInstance().parse(Element.VARIABLE_NAME_PARENT_INSTANCE + ".add(" + Element.VARIABLE_NAME_ELEMENT_INSTANCE + ")");
			return new org.jicengine.element.WrapperActionElement(child, getLocation(), addToListOperation);
		} catch (SyntaxException e){
			throw new ElementException(e, getName(), getLocation());
		}
	}

}
