package org.jicengine.element.impl;

import org.jicengine.expression.SyntaxException;
import org.jicengine.operation.Operation;
import org.jicengine.element.*;

/**
 * @author    .timo
 * @created   28. elokuuta 2004
 */

public class MapCompiler extends ElementCompiler {

	public MapCompiler(String name, Location location)
	{
		super(name, location);
	}

	public void elementInitialized() throws ElementException
	{
		super.elementInitialized();
		if( getElement().getConstructor() == null ){
			setConstructor("new java.util.HashMap()");
		}
	}

	protected ActionElement handleExtraChildElement(ValueElement child) throws org.jicengine.element.ElementException
	{
		String actionExpression = Element.VARIABLE_NAME_PARENT_INSTANCE + ".put('" + child.getName() + "'," + Element.VARIABLE_NAME_ELEMENT_INSTANCE + ")";
		try {

			Operation putToMapOperation = org.jicengine.expression.LJEParser.getInstance().parse(actionExpression);

			return new WrapperActionElement(
				child,
				getLocation(),
				putToMapOperation);

		} catch (org.jicengine.expression.SyntaxException e){
			// is this the error of the child or the parent?
			throw new ElementException(e,getName(), getLocation());
		}
	}
}
