package org.jicengine.expression;

import org.jicengine.operation.Operation;

/**
 * 'Limited Java Expression'-parser.
 *
 *
 *
 * @author .timo
 *
 */

public class LJEParser implements Parser {

	private static LJEParser instance = new LJEParser();

	public static LJEParser getInstance()
	{
		return instance;
	}

	Parser parser;

	private LJEParser() {
		// the order of the sub-parsers matters!

		// these atoms can be part of a FieldValue- or
		// MethodInvocation-expressions
		Parser atomParser = new CompositeParser(new Parser[]{
			new StringParser(),
			new BooleanParser(),
			new NumberParser(),
			new VariableParser(),
			new ClassParser()
		});

		// these parsers define the actual LJE-expressions.
		parser = new CompositeParser(new Parser[]{
			new StringParser(),
			new BooleanParser(),
			new NumberParser(),
			new VariableParser(),
			// note: no class-parser here
			new FieldValueParser(atomParser),
			new MethodInvocationParser(atomParser)
		});
	}

	public Operation parse(String expression) throws SyntaxException
	{
		return this.parser.parse(expression);
	}
}
