package org.jicengine.io;

import java.io.*;

/**
 *
 *
 * @author .timo
 * @version 1.0
 */

public class FileResource extends AbstractResource implements UrlReadable {

	private File file;

	public FileResource(File file)
	{
		super(file.getName());
		this.file = file;
	}

	public File getFile()
	{
		return this.file;
	}

	public File toFile()
	{
		return getFile();
	}

	public java.net.URL getUrl() throws IOException
	{
		try {
			return getFile().toURL();
		} catch (java.net.MalformedURLException e){
			throw new IOException("Failed to transform FileResource to URL: " + e);
		}
	}

	public boolean isAvailable()
	{
		return getFile().canRead();
	}

	public InputStream getInputStream() throws java.io.IOException
	{
		return new FileInputStream(getFile());
	}

	public Resource getResource(String relativePath)
	{
		File baseFile = getFile();
		if( !baseFile.isDirectory() ){
			baseFile = baseFile.getParentFile();
		}
		return new FileResource(new File(baseFile, relativePath));
	}
}
