package org.jicengine.operation;

import org.jicengine.operation.OperationException;

import org.jicengine.operation.MethodInvocationOperation;

import org.jicengine.operation.ConstructionOperation;

import org.jicengine.expression.*;
import org.jicengine.operation.Operation;

/**
 *
 *
 *
 *
 * @author .timo
 *
 */

public class ArrayConstructionOperation extends MethodInvocationOperation {

	public ArrayConstructionOperation(String signature, Operation componentType, Operation length)
	{
		super(signature, componentType, new Operation[]{length});
	}

	protected Object execute(Object componentType, Object[] parameters) throws OperationException
	{
		try {
			return constructArray((Class) componentType, parameters[0]);
		} catch (RuntimeException e){
			throw e;
		} catch (Exception e){
			throw new OperationException(e.toString(), e);
		}
	}

	/**
	 * instantiates a class.
	 */
	private Object constructArray(Class componentType, Object parameter) throws Exception {
		int length;
		if( parameter instanceof Integer ){
			length = ((Integer)parameter).intValue();
		}
		else {
			throw new OperationException("Can't create array, expected the length parameter '" + parameter + "' to be an integer, not of type '" + parameter.getClass().getName() + "'");
		}

		return java.lang.reflect.Array.newInstance(componentType, length);
	}

}
