package org.jicengine.operation;

import java.util.Collection;

/**
 *
 * @author .timo
 *
 */

public class SimpleMethodInvocationOperation extends MethodInvocationOperation {

	String methodName;

	public SimpleMethodInvocationOperation(String signature, Operation actor, String methodName, Operation[] parameters)
	{
		super(signature, actor, parameters);
		this.methodName = methodName;
	}

	public Object execute(Object actor, Object[] parameters) throws OperationException
	{
		try {
			if( actor instanceof Class ){
				// invoke a static method.
				return ReflectionUtils.invokeStaticMethod((Class)actor, this.methodName, parameters);
			}
			else {
				// invoke a method of the actor-instance.
				return ReflectionUtils.invokeMethod(actor, this.methodName, parameters);
			}
		} catch (java.lang.reflect.InvocationTargetException e){
			// InvocationTargetException means that the invoked method threw an exception
			// catch it and throw a CDLElementException that has the correct application-exception..
			throw new OperationException("'" + toString() + "' resulted in exception", e.getTargetException());
		} catch (Exception e2){
			throw new OperationException("'" + toString() + "': " + e2.getMessage(), e2);
		}
	}

}
