package org.jicengine.test;

import junit.framework.TestCase;

/**
 *
 *
 *
 *
 * @author .timo
 *
 */

public class ActionTest extends TestCase {

	private static String message;

	public static void setMessage(String newMessage)
	{
		message = newMessage;
	}

	public void testStaticMethodCall() throws Exception
	{
		setMessage(null);
		Utils.buildJicFragment("<a action=\"org.jicengine.test.ActionTest.setMessage('message set in action-attribute')\"/>");
		assertEquals("message set in action-attribute", message);
		setMessage(null);
	}

	public void testActionsOnParent() throws Exception
	{
		String jic = "";
		jic += "<testObject instance=\"new org.jicengine.test.TestObject()\">";
		jic += "  <name action=\"setName(this)\">test-object</name>";
		jic += "  <doubleValue action=\"setDoubleValue(this)\" type=\"double\">1.234</doubleValue>";
		jic += " <intValue action=\"setIntValue(this)\" type=\"int\">-123456</intValue>";
		jic += "</testObject>";

		Object result = Utils.buildJicFragment(jic);

		assertTrue(result instanceof TestObject);
		TestObject testObject = (TestObject) result;
		assertEquals("test-object", testObject.getName());
		assertEquals(1.234, testObject.getDoubleValue(), 0.0001);
		assertEquals(-123456, testObject.getIntValue());
	}
}
