package org.jicengine.test;

import junit.framework.TestCase;

/**
 *
 *
 *
 *
 * @author .timo
 *
 */

public class ArrayTest extends TestCase {

	public void testEmptyArray() throws Exception {

		Object result = Utils.buildJicFragment("<a type=\"array\"/>");
		assertTrue(result instanceof Object[]);
		assertTrue(((Object[])result).length == 0);
	}

	public void testEmptyObjectArrays() throws Exception {
		Object result;

		result = Utils.buildJicFragment("<a class=\"java.lang.Object[]\" type=\"array\"/>");
		assertTrue(result instanceof Object[]);

		result = Utils.buildJicFragment("<a class=\"java.lang.String[]\" type=\"array\"/>");
		assertTrue(result instanceof String[]);

		result = Utils.buildJicFragment("<a class=\"java.util.Date[]\" type=\"array\"/>");
		assertTrue(result instanceof java.util.Date[]);
	}

	public void testEmptyPrimitiveArrays() throws Exception {
		Object result;

		result = Utils.buildJicFragment("<a class=\"int[]\" type=\"array\"/>");
		assertTrue(result instanceof int[]);

		result = Utils.buildJicFragment("<a class=\"double[]\" type=\"array\"/>");
		assertTrue(result instanceof double[]);

		result = Utils.buildJicFragment("<a class=\"boolean[]\" type=\"array\"/>");
		assertTrue(result instanceof boolean[]);

		result = Utils.buildJicFragment("<a class=\"long[]\" type=\"array\"/>");
		assertTrue(result instanceof long[]);

		result = Utils.buildJicFragment("<a class=\"float[]\" type=\"array\"/>");
		assertTrue(result instanceof float[]);
	}

	public void testObjectArrays() throws Exception {
		String jic = "<a class=\"java.lang.String[]\" type=\"array\">";
		jic += " <e>element 1</e>";
		jic += " <e>element 2</e>";
		jic += " <el>element 3</el>";
		jic += "</a>";
		Object[] result = (Object[]) Utils.buildJicFragment(jic);
		Object[] expected = new String[]{"element 1", "element 2", "element 3"};
		assertTrue(java.util.Arrays.equals(result, expected));
	}

	public void testIntArray() throws Exception {
		String jic = "<a class=\"int[]\" type=\"array\">";
		jic += " <e type=\"int\">1</e>";
		jic += " <e type=\"int\">2</e>";
		jic += " <el type=\"int\">3</el>";
		jic += "</a>";
		int[] result = (int[]) Utils.buildJicFragment(jic);
		int[] expected = new int[]{1,2,3};
		assertTrue(java.util.Arrays.equals(result, expected));
	}

	public void testIntegerArray() throws Exception {
		String jic = "<a class=\"java.lang.Integer[]\" type=\"array\">";
		jic += " <e type=\"int\">1</e>";
		jic += " <e type=\"int\">2</e>";
		jic += " <el type=\"int\">3</el>";
		jic += "</a>";
		Integer[] result = (Integer[]) Utils.buildJicFragment(jic);
		Integer[] expected = new Integer[]{new Integer(1),new Integer(2),new Integer(3)};
		assertTrue(java.util.Arrays.equals(result, expected));
	}

	public void testBooleanArray() throws Exception {
		String jic = "<a class=\"boolean[]\" type=\"array\">";
		jic += " <e type=\"boolean\">true</e>";
		jic += "</a>";
		boolean[] result = (boolean[]) Utils.buildJicFragment(jic);
		boolean[] expected = new boolean[]{true};
		assertTrue(java.util.Arrays.equals(result, expected));
	}

}
