package org.jicengine.test;

import junit.framework.TestCase;

/**
 *
 *
 *
 *
 * @author .timo
 *
 */

public class ClassAttributeTest extends TestCase {

	public static class InnerClass {

	}

	public void testClassAttribute() throws Exception
	{
		String jic = "<e class=\"java.lang.String\" instance=\"'hello'\"/>";
		Utils.jicFragmentEquals(jic, "hello");

		jic = "<e class=\"java.util.Map\" instance=\"new java.util.HashMap()\"/>";
		Utils.jicFragmentEquals(jic, new java.util.HashMap());
	}

	public void testClassAttributeConstrains() throws Exception
	{
		String jic = "<e class=\"java.lang.String\" instance=\"new java.util.Date'\"/>";
		try {
			Utils.buildJicFragment(jic);
			fail();
		} catch (Exception e){
		}
	}

	public void testBothParametersAndValueNotAllowed() throws Exception
	{
		String jic = "<e instance=\"new java.util.Date'\" parameters=\"joku\"/>";
		try {
			Utils.buildJicFragment(jic);
			fail();
		} catch (Exception e){
		}
	}

	public void testConstructorFromClassAttribute() throws Exception
	{
		String jic = "<e class=\"java.util.HashMap\"/>";
		Utils.jicFragmentEquals(jic, new java.util.HashMap());
	}

	public void testConstructorFromClassAndParametersAttributes() throws Exception
	{
		String jic;
		jic = "<e class=\"java.net.URL\" parameters=\"'http://www.google.com'\"/>";
		Utils.jicFragmentEquals(jic, new java.net.URL("http://www.google.com"));

		jic = "<url class=\"java.net.URL\" parameters=\"address\"><address>http://www.google.com</address></url>";
		Utils.jicFragmentEquals(jic, new java.net.URL("http://www.google.com"));
	}

	public void testClassAttributeAndCdataElement() throws Exception
	{
		String jic;
		//jic = "<e class=\"java.lang.String\">Hello World!</e>";
		//Utils.jicFragmentEquals(jic, "Hello World!");

		jic = "<e class=\"java.lang.Integer\" type=\"int\">1234</e>";
		Utils.jicFragmentEquals(jic, new Integer(1234));

		jic = "<e class=\"java.lang.Double\" type=\"double\">12.34</e>";
		Utils.jicFragmentEquals(jic, new Double(12.34));

	}

	public void testInnerClass() throws Exception
	{
		String jic;
		Object result;

		jic = "<e class=\"org.jicengine.test.ClassAttributeTest$InnerClass\"/>";
		result = Utils.buildJicFragment(jic);
		assertTrue(result instanceof InnerClass);
	}

	public void testPrimitiveArrays() throws Exception
	{
		String jic;
		Object result;

		jic = "<char-array class=\"char[]\" instance=\"CDATA.toCharArray()\">hello</char-array>";
		result = Utils.buildJicFragment(jic);
		assertTrue("Expected a char[]", result instanceof char[]);
		assertTrue(java.util.Arrays.equals("hello".toCharArray(),((char[])result) ));
	}

}
