package org.jicengine.test;

import junit.framework.TestCase;
import java.util.*;

/**
 *
 *
 *
 *
 * @author .timo
 *
 */

public class MapTest extends TestCase {

	public void testStringMap() throws Exception
	{
		String jic;
		Map expected;

		jic = "<map type=\"map\">";
		jic +=  "<key1>Value 1</key1>";
		jic += "</map>";
		expected = new HashMap();
		expected.put("key1", "Value 1");
		Utils.jicFragmentEquals(jic, expected);
	}

	public void testStringMapWithConstructor() throws Exception
	{
		String jic;
		Map expected;

		jic = "<map type=\"map\" instance=\"new java.util.Properties()\">";
		jic +=  "<key1>Value 1</key1>";
		jic += "</map>";
		expected = new HashMap();
		expected.put("key1", "Value 1");
		Object result = Utils.buildJicFragment(jic);
		assertTrue("Expected result to a Properties-instance.", result instanceof Properties);
		assertEquals(expected, result);

	}

	public void testMapWithActionChildren() throws Exception
	{
		String jic;
		Map expected;

		jic = "<map type=\"map\">";
		jic +=  "<key1>Value 1</key1>";
		// use integer as the key
		jic +=  "<key2 action=\"put(12,this)\">Value 2</key2>";
		jic += "</map>";
		expected = new HashMap();
		expected.put("key1", "Value 1");
		expected.put(new Integer(12), "Value 2");
		Utils.jicFragmentEquals(jic, expected);
	}

	/*
	public void testCdataMap() throws Exception
	{
		String jic;
		Map expected;

		jic = "<map type=\"map()\">";
		jic += "Key1=Value1";
		jic += "</map>";
		expected = new HashMap();
		expected.put("Key1", "Value1");
		Utils.jicFragmentEquals(jic, expected);
	}
	*/
/*
	public void testNoImplicitConstructorCreatedFromClassAttribute() throws Exception
	{
		String jic;
		Map expected;

		// although class=Map, the default-Map-instance should be created
		// i.e. a HashMap.
		jic = "<map class=\"java.util.Map\" type=\"map()\">";
		jic += "Key1=Value1";
		jic += "</map>";
		expected = new HashMap();
		expected.put("Key1", "Value1");
		Object result = Utils.buildJicFragment(jic);
		assertTrue(result instanceof java.util.Map);
		assertEquals(expected, result);
	}
*/

	public void testParametersAttribute() throws Exception
	{
		String jic;
		Map expected;

		jic = "<map class=\"java.util.HashMap\" parameters=\"2\" type=\"map\">";
		jic += "<Key1>Value1</Key1>";
		jic += "</map>";
		expected = new HashMap();
		expected.put("Key1", "Value1");
		Object result = Utils.buildJicFragment(jic);
		assertTrue(result instanceof java.util.HashMap);
		assertEquals(expected, result);
	}

	public void testEmptyMap() throws Exception
	{
		String jic;
		Map expected;

		jic = "<map type=\"map\"/>";
		expected = new HashMap();
		Utils.jicFragmentEquals(jic, expected);

		jic = "<map class=\"java.util.Properties\" type=\"map\" instance=\"new java.util.Properties()\"/>";
		expected = new HashMap();
		Utils.jicFragmentEquals(jic, expected);

	}


}
