package org.jicengine.tools;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.net.*;
import org.jicengine.io.Resource;
import org.jicengine.io.UrlResource;
import java.io.*;

/**
 *
 *
 *
 *
 * @author .timo
 *
 */

public class ShellWindow extends JApplet {

	JTextArea jic;
	JTextArea result;

	JSplitPane middlePanel;

	public ShellWindow()
	{
	}

	public void init()
	{
		//super("JICE Shell");

		jic = new JTextArea("<?xml version=\"1.0\"?>\n<e xmlns=\"http://www.jicengine.org/jic/1.0\">Hello</e>\n", 15,40);
		jic.setFont(new Font("Courier", Font.PLAIN, 11));
		jic.setTabSize(2);

		JButton run = new JButton(new AbstractAction("Process"){
			public void actionPerformed(ActionEvent e)
			{
				updateResult();
			}
		});
		run.setToolTipText("Ctrl+Enter");
		run.setMnemonic(KeyEvent.VK_P);

		run.getInputMap(JComponent.WHEN_IN_FOCUSED_WINDOW).put(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, KeyEvent.CTRL_MASK), "run-command");
		run.getActionMap().put("run-command", run.getAction());

		result = new JTextArea("", 10,40);
		result.setFont(new Font("Courier", Font.PLAIN, 11));
		result.setTabSize(4);

		JScrollPane jicScrollPane = new JScrollPane(jic);
		JScrollPane resultScrollPane = new JScrollPane(result);

		JSplitPane middlePanel = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
		this.middlePanel = middlePanel;
		middlePanel.add(jicScrollPane);
		middlePanel.add(resultScrollPane);


		getContentPane().add(run, BorderLayout.NORTH);
		getContentPane().add(middlePanel, BorderLayout.CENTER);

		try {
			Class.forName("org.jicengine.element.ElementCompiler");
		} catch (Exception e){
			e.printStackTrace();
		}

		String jicFileParam = getParameter("jicFile");
		if( jicFileParam != null ){
			try {
				URL url = new URL(getCodeBase(), jicFileParam);
				Resource resource = new UrlResource(url);

				StringWriter writer = new StringWriter();
				resource.writeTo(writer);

				jic.setText(writer.getBuffer().toString());
			} catch (MalformedURLException e2){
				e2.printStackTrace();
			} catch (java.io.IOException e){
				e.printStackTrace();
			}
		}
	}

	public void start()
	{
		//
		middlePanel.setDividerLocation(0.60);
	}

	private void updateResult()
	{
		try {
			String jic = this.jic.getText();
			Object result = org.jicengine.JICE.build(new org.jicengine.io.StringResource("jic", jic,new org.jicengine.io.FileResource(new java.io.File("."))) );
			this.result.setText(formatResult(result));
		} catch (Exception e){
			java.io.StringWriter writer = new java.io.StringWriter();

			e.printStackTrace(new java.io.PrintWriter(writer, true));

			this.result.setText(writer.getBuffer().toString());
		}
	}

	private String formatResult(Object result)
	{
		String resultString = "Class: ";
		resultString += formatResultClass(result);
		resultString += "\n";
		resultString += "Value: ";
		resultString += formatResultValue(result);
		resultString += "\n";

		return resultString;
	}

	private String formatResultClass(Object result)
	{
		if( result == null ){
			return "?";
		}
		else if( result.getClass().isArray() ){
			return result.getClass().getComponentType().getName() + "[]";
		}
		else {
			return result.getClass().getName();
		}
	}

	private String formatResultValue(Object result)
	{
		if( result == null ){
			return "null";
		}
		else	if( result.getClass().isArray() ){
			int length = java.lang.reflect.Array.getLength(result);
			StringBuffer resultString = new StringBuffer();
			resultString.append("{");
			Class componentType = result.getClass().getComponentType();
			for (int i = 0; i < length; i++) {
				if( !componentType.isPrimitive() ){
					resultString.append(java.lang.reflect.Array.get(result, i));
				}
				else if( componentType.equals(Integer.TYPE) ){
					resultString.append(java.lang.reflect.Array.getInt(result, i));
				}
				else if( componentType.equals(Double.TYPE) ){
					resultString.append(java.lang.reflect.Array.getDouble(result, i));
				}
				else if( componentType.equals(Boolean.TYPE) ){
					resultString.append(java.lang.reflect.Array.getBoolean(result, i));
				}
				else if( componentType.equals(Long.TYPE) ){
					resultString.append(java.lang.reflect.Array.getLong(result, i));
				}
				else if( componentType.equals(Float.TYPE) ){
					resultString.append(java.lang.reflect.Array.getDouble(result, i));
				}
				else if( componentType.equals(Character.TYPE) ){
					resultString.append(java.lang.reflect.Array.getChar(result, i));
				}
				else {
					resultString.append("?");
				}
				if( (i+1) < length ){
					resultString.append(", ");
				}
			}
			resultString.append("}");
			return resultString.toString();
		}
		else {
			return result.toString();
		}
	}

	public static void main(String[] args)
	{

		// create the applet
		ShellWindow window = new ShellWindow();
		//window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		window.init();

		final JFrame frame = new JFrame("JICE: Shell Window");
		frame.setContentPane(window.getContentPane());

		frame.setJMenuBar(window.getJMenuBar());

		// Add a window listener to the frame for shutting
		// down the application.
		frame.addWindowListener(new WindowAdapter() {
				public void windowClosing(WindowEvent e) {
			frame.dispose();
			System.exit(0);
				}
		});

		// Set the size of the frame.
		// To pack the frame as tightly as possible
		// replace the setSize() message with the following.
		// frame.pack();
		frame.setSize(500,400);

		// Set the location of the frame.
		frame.setLocation(200,200);

		// Show the frame.
		frame.show();

		// Invoke the applet's start() method.
		// This line can be omitted if the applet
		// does not define a start method.
		window.start();

	}
}
