package org.jicengine.util;
import java.io.PrintWriter;
import java.io.PrintStream;
/**
 * @author .timo
 * @version 1.0
 */

public class ChainedRuntimeException extends RuntimeException {

	private Throwable cause;

	public ChainedRuntimeException() {
		super();
	}

	public ChainedRuntimeException(String message){
		super(message);
	}

	public ChainedRuntimeException(String message, Throwable cause){
		super(message);
		initCause(cause);
	}

	public ChainedRuntimeException(Throwable cause){
		super( (cause==null ? null : cause.toString()));
		initCause(cause);
	}

	public Throwable initCause(Throwable cause){
		this.cause = cause;
		return this;
	}

	public void printStackTrace(){
		super.printStackTrace();

		if( this.cause != null ){
			System.err.print("Caused by:");
			this.cause.printStackTrace();
		}
	}

	public void printStackTrace(PrintStream s){
		super.printStackTrace(s);

		if( this.cause != null ){
			s.print("Caused by:");
			this.cause.printStackTrace(s);
		}
	}

	public void printStackTrace(PrintWriter s){
		super.printStackTrace(s);

		if( this.cause != null ){
			s.print("Caused by:");
			this.cause.printStackTrace(s);
		}
	}

}
